import { z } from 'zod';
import type { ReleaseResult } from '../types';
export declare const MinifiedArray: z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnknown>, "many">, Record<string, unknown>[], Record<string, unknown>[]>;
export type MinifiedArray = z.infer<typeof MinifiedArray>;
export declare const ComposerRelease: z.ZodObject<z.extendShape<{
    version: z.ZodString;
}, {
    homepage: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodString>>>;
    source: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodObject<{
        url: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        url: string;
    }, {
        url: string;
    }>>>>;
    time: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodString>>>;
    require: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodObject<{
        php: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        php: string;
    }, {
        php: string;
    }>>>>;
}>, "strip", z.ZodTypeAny, {
    source?: {
        url: string;
    } | null | undefined;
    require?: {
        php: string;
    } | null | undefined;
    time?: string | null | undefined;
    homepage?: string | null | undefined;
    version: string;
}, {
    source?: {
        url: string;
    } | null | undefined;
    require?: {
        php: string;
    } | null | undefined;
    time?: string | null | undefined;
    homepage?: string | null | undefined;
    version: string;
}>;
export type ComposerRelease = z.infer<typeof ComposerRelease>;
export declare const ComposerReleases: z.ZodEffects<z.ZodArray<z.ZodCatch<z.ZodNullable<z.ZodObject<z.extendShape<{
    version: z.ZodString;
}, {
    homepage: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodString>>>;
    source: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodObject<{
        url: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        url: string;
    }, {
        url: string;
    }>>>>;
    time: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodString>>>;
    require: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodObject<{
        php: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        php: string;
    }, {
        php: string;
    }>>>>;
}>, "strip", z.ZodTypeAny, {
    source?: {
        url: string;
    } | null | undefined;
    require?: {
        php: string;
    } | null | undefined;
    time?: string | null | undefined;
    homepage?: string | null | undefined;
    version: string;
}, {
    source?: {
        url: string;
    } | null | undefined;
    require?: {
        php: string;
    } | null | undefined;
    time?: string | null | undefined;
    homepage?: string | null | undefined;
    version: string;
}>>>, "many">, {
    source?: {
        url: string;
    } | null | undefined;
    require?: {
        php: string;
    } | null | undefined;
    time?: string | null | undefined;
    homepage?: string | null | undefined;
    version: string;
}[], ({
    source?: {
        url: string;
    } | null | undefined;
    require?: {
        php: string;
    } | null | undefined;
    time?: string | null | undefined;
    homepage?: string | null | undefined;
    version: string;
} | null | undefined)[]>;
export type ComposerReleases = z.infer<typeof ComposerReleases>;
export declare const ComposerPackagesResponse: z.ZodObject<{
    packages: z.ZodRecord<z.ZodString, z.ZodUnknown>;
}, "strip", z.ZodTypeAny, {
    packages: Record<string, unknown>;
}, {
    packages: Record<string, unknown>;
}>;
export declare function parsePackagesResponse(packageName: string, packagesResponse: unknown): ComposerReleases;
export declare function parsePackagesResponses(packageName: string, packagesResponses: unknown[]): ReleaseResult | null;
declare const RegistryFile: z.ZodObject<{
    key: z.ZodString;
    sha256: z.ZodString;
}, "strip", z.ZodTypeAny, {
    key: string;
    sha256: string;
}, {
    key: string;
    sha256: string;
}>;
export type RegistryFile = z.infer<typeof RegistryFile>;
export declare const RegistryMeta: z.ZodEffects<z.ZodObject<{
    packages: z.ZodCatch<z.ZodNullable<z.ZodRecord<z.ZodString, z.ZodRecord<z.ZodString, z.ZodObject<z.extendShape<{
        version: z.ZodString;
    }, {
        homepage: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodString>>>;
        source: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodObject<{
            url: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            url: string;
        }, {
            url: string;
        }>>>>;
        time: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodString>>>;
        require: z.ZodOptional<z.ZodCatch<z.ZodNullable<z.ZodObject<{
            php: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            php: string;
        }, {
            php: string;
        }>>>>;
    }>, "strip", z.ZodTypeAny, {
        source?: {
            url: string;
        } | null | undefined;
        require?: {
            php: string;
        } | null | undefined;
        time?: string | null | undefined;
        homepage?: string | null | undefined;
        version: string;
    }, {
        source?: {
            url: string;
        } | null | undefined;
        require?: {
            php: string;
        } | null | undefined;
        time?: string | null | undefined;
        homepage?: string | null | undefined;
        version: string;
    }>>>>>;
    includes: z.ZodEffects<z.ZodCatch<z.ZodNullable<z.ZodEffects<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodCatch<z.ZodNullable<z.ZodObject<{
        sha256: z.ZodNullable<z.ZodString>;
    }, "strip", z.ZodTypeAny, {
        sha256: string | null;
    }, {
        sha256: string | null;
    }>>>>, Record<string, {
        sha256: string | null;
    }>, Record<string, {
        sha256: string | null;
    } | null | undefined>>, {
        key: string;
        sha256: string;
    }[], Record<string, {
        sha256: string | null;
    } | null | undefined>>>>, {
        key: string;
        sha256: string;
    }[], Record<string, {
        sha256: string | null;
    } | null | undefined> | null | undefined>;
    "provider-includes": z.ZodEffects<z.ZodCatch<z.ZodNullable<z.ZodEffects<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodCatch<z.ZodNullable<z.ZodObject<{
        sha256: z.ZodNullable<z.ZodString>;
    }, "strip", z.ZodTypeAny, {
        sha256: string | null;
    }, {
        sha256: string | null;
    }>>>>, Record<string, {
        sha256: string | null;
    }>, Record<string, {
        sha256: string | null;
    } | null | undefined>>, {
        key: string;
        sha256: string;
    }[], Record<string, {
        sha256: string | null;
    } | null | undefined>>>>, {
        key: string;
        sha256: string;
    }[], Record<string, {
        sha256: string | null;
    } | null | undefined> | null | undefined>;
    "providers-url": z.ZodCatch<z.ZodNullable<z.ZodString>>;
    "providers-lazy-url": z.ZodCatch<z.ZodNullable<z.ZodOptional<z.ZodString>>>;
    providers: z.ZodCatch<z.ZodEffects<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodCatch<z.ZodNullable<z.ZodObject<{
        sha256: z.ZodNullable<z.ZodString>;
    }, "strip", z.ZodTypeAny, {
        sha256: string | null;
    }, {
        sha256: string | null;
    }>>>>, Record<string, {
        sha256: string | null;
    }>, Record<string, {
        sha256: string | null;
    } | null | undefined>>, Record<string, string | null>, Record<string, {
        sha256: string | null;
    } | null | undefined>>>;
}, "strip", z.ZodTypeAny, {
    packages: Record<string, Record<string, {
        source?: {
            url: string;
        } | null | undefined;
        require?: {
            php: string;
        } | null | undefined;
        time?: string | null | undefined;
        homepage?: string | null | undefined;
        version: string;
    }>> | null;
    includes: {
        key: string;
        sha256: string;
    }[];
    "provider-includes": {
        key: string;
        sha256: string;
    }[];
    "providers-url": string | null;
    "providers-lazy-url": string | null;
    providers: Record<string, string | null>;
}, {
    packages?: Record<string, Record<string, {
        source?: {
            url: string;
        } | null | undefined;
        require?: {
            php: string;
        } | null | undefined;
        time?: string | null | undefined;
        homepage?: string | null | undefined;
        version: string;
    }>> | null | undefined;
    includes?: Record<string, {
        sha256: string | null;
    } | null | undefined> | null | undefined;
    "provider-includes"?: Record<string, {
        sha256: string | null;
    } | null | undefined> | null | undefined;
    "providers-url"?: string | null | undefined;
    "providers-lazy-url"?: string | null | undefined;
    providers?: Record<string, {
        sha256: string | null;
    } | null | undefined> | undefined;
}>, {
    packages: Record<string, Record<string, {
        source?: {
            url: string;
        } | null | undefined;
        require?: {
            php: string;
        } | null | undefined;
        time?: string | null | undefined;
        homepage?: string | null | undefined;
        version: string;
    }>> | null;
    includes: {
        key: string;
        sha256: string;
    }[];
    providers: Record<string, string | null>;
    providerIncludes: {
        key: string;
        sha256: string;
    }[];
    providersUrl: string | null;
    providersLazyUrl: string | null;
}, {
    packages?: Record<string, Record<string, {
        source?: {
            url: string;
        } | null | undefined;
        require?: {
            php: string;
        } | null | undefined;
        time?: string | null | undefined;
        homepage?: string | null | undefined;
        version: string;
    }>> | null | undefined;
    includes?: Record<string, {
        sha256: string | null;
    } | null | undefined> | null | undefined;
    "provider-includes"?: Record<string, {
        sha256: string | null;
    } | null | undefined> | null | undefined;
    "providers-url"?: string | null | undefined;
    "providers-lazy-url"?: string | null | undefined;
    providers?: Record<string, {
        sha256: string | null;
    } | null | undefined> | undefined;
}>;
export type RegistryMeta = z.infer<typeof RegistryMeta>;
export {};
